<?php


namespace Ardent\ParameterBundle\DependencyInjection;


use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

class Configuration implements ConfigurationInterface
{
    public const TYPE_TEXT = 'text';
    public const TYPE_NUMBER = 'number';

    public function getConfigTreeBuilder()
    {
        $treeBuilder = new TreeBuilder('ardent_parameter');

        $treeBuilder->getRootNode()
            ->children()
                ->arrayNode('parameters')
                    ->arrayPrototype()
                        ->children()
                            ->scalarNode('group')->defaultValue('misc')->end()
                            ->arrayNode('values')
                                ->arrayPrototype()
                                    ->children()
                                        ->scalarNode('name')->end()
                                        ->enumNode('type')
                                            ->values([self::TYPE_TEXT, self::TYPE_NUMBER])
                                            ->defaultValue(self::TYPE_TEXT)
                                        ->end()
                                    ->end()
                                ->end()
                            ->end()
                        ->end()
                    ->end()
                ->end()
            ->end();

        return $treeBuilder;
    }
}